module RSpec
  module Strict
    module Let
      DEFINITIONS = Hash.new

      def let(name, &block)
        definition = caller.first.dup.freeze
        Let::DEFINITIONS[definition] = name

        super

        wrapper =
          Module.new do
            define_method(name) do
              Let::DEFINITIONS.delete(definition)

              super()
            end
          end

        prepend(wrapper)
      end
    end
  end
end

RSpec::Core::ExampleGroup.extend(RSpec::Strict::Let)
